// (C) 2003 Ulrich Hecht <uli@emulinks.de>
// Licensed under the terms of the GNU Public License version 2

#include "f2a.h"
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <stdio.h>

int f2a_boot(char* bootfile)
{
	sendmsg sm;
	unsigned int ack[16];
	
	int i;
	int mbf;
	unsigned char* mb;

	memset(&sm, 0, sizeof(sm));

	mbf=open(bootfile,O_RDONLY);
	if(mbf==-1)
	{
		perror("unable to open GBA client binary");
		return -1;
	}

	mb=mmap(0,16*1024,PROT_READ,MAP_SHARED,mbf,0);
	if(mb==MAP_FAILED)
	{
		perror("unable to mmap() GBA client binary");
		return -1;
	}

	// boot the GBA
	sm.command=CMD_MULTIBOOT1;
	sendf2a(sm);
	sm.command=CMD_MULTIBOOT2;
	sm.size=16*1024;
	sendf2a(sm);
	
	// send the multiboot image
	for(i=0;i<16;i++)
		if(usb_write(mb+i*1024, 1024)==-1) return -1;
	
	if(usb_read((char*)ack, 16*sizeof(int))==-1) return -1;

	if(verbose>=2)
	{
		printf("post-boot:");
		for(i=0;i<16;i++)
			printf(" %08X", ack[i]);
		puts("");
	}

	munmap(mb,16*1024);
	close(mbf);
	return 0;
}

