/*
Author: David Voswinkel
Email:  d.voswinkel@netcologne.de
Date:   2003-07-27 16:43:38

$Id: parport.h,v 1.3 2003/07/27 17:24:10 david Exp $

$Log: parport.h,v $
Revision 1.3  2003/07/27 17:24:10  david
added read cart

Revision 1.2  2003/07/27 14:28:51  david
*** empty log message ***

*/



#ifndef PARPORT_H
#define PARPORT_H

#include "f2a.h"


typedef struct
{
	unsigned char head[16];
	unsigned char cmd;
	unsigned char unkown;
	unsigned int  size;
	unsigned char _reserved1[58];

} __attribute__ ((packed)) parport_msg_head_t;


typedef struct
{
	unsigned int _reserved1[3];
	unsigned int magic;
	unsigned int cmd;
	unsigned int addr;
	unsigned int sizekb;
	unsigned int _reserved2;
	unsigned int exec;
	unsigned int exec_stub;
	unsigned char _reserved3[984];

} __attribute__ ((packed)) parport_msg_cmd_t;


#define PP_CMD_WRITEDATA 	0x06
#define PP_CMD_READDATA 	0x07
#define PP_CMD_WRITEROM 	0x0a
#define PP_CMD_ERASE 		0x0b
#define PP_HEAD_BOOT		0x01
#define PP_HEAD_READ		0x07
#define PP_HEAD_WRITE 		0x06
#define PP_MAGIC_NUMBER 	0xa46e5b91

#define LOGO_ADDR				0x06000000
#define EXEC_STUB				0x03002000
#define ERASE_STUB				0x03000c00
#define LOGO_SIZE				76800
#define BOOT_SIZE				18432
#define HEAD_SIZE				160
#define LOADER_SIZE				32768


#define FLIP 	1
#define HEAD 	1
#define EXEC    1



int parport_init(int pbase);
int parport_boot(int upload_logo);
int parport_write(int files_cnt,char **files,unsigned int addr);
int parport_read(unsigned int start,unsigned int size, unsigned char * filename );
int parport_erase(unsigned int start,unsigned int size);
int parport_exit();
void parport_enable_debug();
#endif
